//-----------------------------------------
// LScript Generic template
// Copyright 2005 Michael Green
// MikesLscripts@shortbutpurple.fsnet.co.uk
//

myversion=1;
@version 2.2
@warnings
@script generic

// global values go here
myleftstrings=@"Left","lt","left","LT","LEFT","L","Lt"@;
myrightstrings=@"Right","rt","right","RT","RIGHT","R","Rt"@;

fullpose;
poseindex=0;
myprech,myobjch,myposch,myrotch,myscach,mynumch;

c9,c10;

generic
{
    myobjid = globalrecall("MGPoseCopyObject",0);
    mytimestr = globalrecall("MGPoseCopyTime",0.0);
    mycopytime=mytimestr.asNum()/Scene().fps;

    myprech=recall("MGPoseCopyPrech",1);
    myobjch=recall("MGPoseCopyObjch",1);
    myposch=recall("MGPoseCopyPosch",0);
    myrotch=recall("MGPoseCopyRotch",1);
    myscach=recall("MGPoseCopyScach",0);
    mynumch=recall("MGPoseCopyNumch",1);
    myrevch=recall("MGPoseCopyRevch",1);
    mylft=recall("MGPoseCopyLft","Left");
    myrgt=recall("MGPoseCopyRgt","Right");

    copyframe=mycopytime*Scene().fps;
    mypasteframe=Scene().currenttime*Scene().fps;

    myoldobjs =Scene().getSelect();
    if(!myoldobjs)
        error("No objects selected");
    
    SelectItem(myobjid.asInt());
    myobj=Scene().firstSelect();
    if(!myobj)
        error("Copy object not found");

//==================================================================================

    reqbegin("MGPosePaste Ver:"+myversion);

    reqsize(350,360);
	t1 = ctltab("Main","Usage","Settings Help");
	s0 = ctlsep(5,340);

    p1 = ctlchoice("Pose Precision",myprech,@"Precise","Keys Only"@);
    c1 = ctlminislider("Copy Frame",copyframe,Scene().previewstart,Scene().previewend);
    c2 = ctlnumber("Paste Frame",mypasteframe);//,Scene().previewstart,Scene().previewend);
    c3 = ctlchoice("Items",myobjch,@"Children only","Include Parent","Selected only"@);
    c4 = ctlcheckbox("Position",myposch);
    c5 = ctlcheckbox("Rotation",myrotch);
    c6 = ctlcheckbox("Scale",myscach);
    c7 = ctlcheckbox("Ignore non bone LW numerals (e.g. (1),(2))",mynumch);
    c8 = ctlcheckbox("Reverse pose",myrevch);
    c9 = ctlstring("Left denominator",mylft,100);
    c10 = ctlstring("Right denominator",myrgt,100);
    c11 = ctlmenu("Presets",myleftstrings,"myleftUDF");
	ctlposition(c11,200,257);
    c12 = ctlmenu("Presets",myrightstrings,"myrightUDF");
	ctlposition(c12,200,281);

//====================================================================================
// Usage

	h1=ctltext("Contact:",
				"Lscripts@shortbutpurple.fsnet.co.uk");
	ctlposition(h1,10,40);
	h2=ctltext("Step 1:",
				"Select the parent item of the hierarchy you want to copy the pose of.",
                "This could be a mesh for an entire skeleton, or a wrist bone if you ",
                "just want to copy a hand pose, or just some selected items");
	ctlposition(h2,10,70);
	h3=ctltext("Step 2:",
				"Activate MGCopyPose. This remembers the object and frame you",
                "have selected.");
	ctlposition(h3,10,130);
	h4=ctltext("Step 3:",
				"Select the item or items of the hierarchies you wish to paste the pose",
				"to. You can paste the pose to more than one hierarchy, as long as the",
				"items in it have the same names as the pose items.");
	ctlposition(h4,10,170);
	h5=ctltext("Step 4:",
				"Activate MGPosePaste and set the settings as you",
                "want. See the Settings help for more details.");
	ctlposition(h5,10,220);
	h6=ctltext("Note:",
				"By selecting the wrist bone, copying, then selecting multiple mesh ",
                "items, you can paste it to all their hands, since it matches the ",
                "pose by item name.");
	ctlposition(h6,10,260);

//====================================================================================
//settings help
	s1=ctltext("Contact:",
				"Lscripts@shortbutpurple.fsnet.co.uk");
	ctlposition(s1,10,40);
	s2=ctltext("Precision:",
				"Create keys for all values marked below",
                "or just ones which exist at the copy time.");
	ctlposition(s2,10,70);
	s3=ctltext("Copy time/Paste time:",
				"Times to copy from/paste to.");
	ctlposition(s3,10,110);
	s4=ctltext("Items:",
				"You can paste a pose onto an item's children, both parent and",
                "children or only the selected items.");
	ctlposition(s4,10,140);
	s5=ctltext("Position/Rotation/Scale:",
				"Channels to copy.");
	ctlposition(s5,10,180);
	s6=ctltext("Ignore LW numerals:",
				"This is useful for multiple mesh hierarchies where name matching is",
                "a problem. When it tries to match bits of the pose mesh hierarchy to",
                "the destination hierarchies it'll ignore the numeric extension LW",
                "uses to distinguish between them. It's not usually necessary for",
                "bones, but for say robots it could be handy.");
	ctlposition(s6,10,210);
	s7=ctltext("Reverse pose",
				"Mirror the pose, using the two strings to show which side is which.");
	ctlposition(s7,10,290);

//=======================================================================================

	ctlpage(1,p1,c1,c2,c3,c4,c5,c6,c7,c8,c9,c10);
	ctlpage(2,h1,h2,h3,h4,h5,h6);
	ctlpage(3,s1,s2,s3,s4,s5,s6,s7);
	
	ctlactive(c8,"reverseon",c9,c10,c11,c12);

    return if !reqpost();

    myprech=getvalue(p1);
    mycopytime=getvalue(c1)/Scene().fps;
    mypastetime=getvalue(c2)/Scene().fps;
    myobjch=getvalue(c3);
    myposch=getvalue(c4);
    myrotch=getvalue(c5);
    myscach=getvalue(c6);
    mynumch=getvalue(c7);
    myrevch=getvalue(c8);
    mylft=getvalue(c9);
    myrgt=getvalue(c10);

    // get requester control values here

    reqend();
    
    store("MGPoseCopyPrech",myprech);
    store("MGPoseCopyObjch",myobjch);
    store("MGPoseCopyPosch",myposch);
    store("MGPoseCopyRotch",myrotch);
    store("MGPoseCopyScach",myscach);
    store("MGPoseCopyNumch",mynumch);
    store("MGPoseCopyRevch",myrevch);
    store("MGPoseCopyLft",mylft);
    store("MGPoseCopyRgt",myrgt);

//=======================================================================

// do it!

    if(myobjch==3)
        getposeselected(myoldobjs,mycopytime);
    else
        mypose=getfullpose(myobj,mycopytime);

    if(myrevch)
        reversepose(mylft,myrgt);

    if(myobjch==3)
        pasteposeselected(myoldobjs,mypastetime);
    else
        pasteposeall(myoldobjs,mypastetime);
    RefreshNow();

//    debug();
    SelectItem(myoldobjs[1].id);
    for(i=2;i<=myoldobjs.size();i++)
    {
        AddToSelection(myoldobjs[i].id);
    }


    StatusMsg("Pose pasted");
}

reverseon:value
{
    return(value);
}

myleftUDF:item
{
    setvalue(c9,myleftstrings[item]);
}

myrightUDF:item
{
    setvalue(c10,myrightstrings[item]);
}

removedigits:pstring
{
    beginning=0;
    myint=nil;
    newstring=pstring;
    if(pstring[pstring.size()]==")")
    {
        for(i=pstring.size()- 1; i>0 ;i--)
        {
            if(pstring[i]=="(")
            {
                beginning=i+1;
                break;
            }
        }
        if(!beginning)
        {
            intstring=strsub(pstring,beginning, pstring.size() - beginning);
            if(intstring.asInt()!=0)
            {
                newstring=strleft(pstring,beginning - 3);
                myint=intstring.asInt();
            }
        }

    }
    return(newstring,myint);

}

reversepose:lstring,rstring
{
    //reverse names, X,H,B, maybe SX?
    for(i=1;i<=fullpose.size();i++)
    {
        myname=fullpose[i][1];
        change=1;
        if(myname.contains(lstring))
            myname=swapstring(myname,lstring,rstring);
        else if(myname.contains(rstring))
            myname=swapstring(myname,rstring,lstring);
        else
            change=0;
        if(change)
        {
            fullpose[i][1]=myname;
            fullpose[i][2][1][2]=fullpose[i][2][1][2]* - 1;
            fullpose[i][2][4][2]=fullpose[i][2][4][2]* - 1;
            fullpose[i][2][6][2]=fullpose[i][2][6][2]* - 1;
        }
    }
}

swapstring:pname,astring,bstring    //swap lstring for
{
//debug();
    mynewname="";
    j=1;
    while(j<=pname.size())
    {
        if(strsub(pname,j,astring.size())==astring)
        {
            mynewname=mynewname+bstring;
            j=j+astring.size() - 1;
        }
        else
            mynewname=mynewname+pname[j];
        j++;
    }
    return(mynewname);
}

pasteposeall:pobjs,ptime
{
    //paste pose into multiple objects
    for(i=1;i<=pobjs.size();i++)
    {
        myobj=pobjs[i];
        if(myobjch==2)
            pastepose(myobj,fullpose[1][2],ptime);
        pastenode(myobj,myobj.firstChild(),ptime);
    }
}

pasteposeselected:pobjs,ptime
{
    for(i=1;i<=pobjs.size();i++)
    {
        for(j=1;j<=fullpose.size();j++)
        {
            if(pobjs[i].id==fullpose[j][1])
            {
                pastepose(pobjs[i],fullpose[j][2],ptime);
            }
        }
    }

}

pastenode:pparent,pchild,ptime
{
    if(!pchild)
        return;
    for(j=2;j<=fullpose.size();j++)
    {
        if(pchild.name==fullpose[j][1])
            pastepose(pchild,fullpose[j][2],ptime);
        else if(mynumch && !pchild.isBone())
        {
            (myname,mydigits)=removedigits(pchild.name);
            (myposename,mydigits)=removedigits(fullpose[j][1]);
            if(myname==myposename)
                pastepose(pchild,fullpose[j][2],ptime);
        }
    }
    mygrandchild=pchild.firstChild();
    pastenode(pchild,mygrandchild,ptime);
    pastenode(pparent,pparent.nextChild(),ptime);
}

pastepose:pobj,posvals,ptime
{
//    info("Pasted onto" + pobj.name);
    //pastevals onto pobj;
//debug();
    groupname=pobj.name;
    
    mygroup=ChannelGroup(groupname);

    if(pobj.isBone())
    {
        myparent=pobj.parent;
        while(myparent.parent)
        {
            myparent=myparent.parent;               // find parent mesh
        }
        myovergroup=ChannelGroup(myparent.name);
        mygroup=ChannelGroup(myovergroup);
        while(mygroup)
        {
            if(mygroup.name==pobj.name)             // get bone group for our bone.
                break;
            mygroup=mygroup.next();
        }
    }

    mychannel=mygroup.firstChannel();

    if(myprech==1)
    {
        while(mychannel)
        {
            if(myposch)
            {
                if(mychannel.name=="Position.X")
                    mychannel.createKey(ptime,posvals[1][2]);
                if(mychannel.name=="Position.Y")
                    mychannel.createKey(ptime,posvals[2][2]);
                if(mychannel.name=="Position.Z")
                    mychannel.createKey(ptime,posvals[3][2]);
            }
    
            if(myrotch)
            {
                if(mychannel.name=="Rotation.H")
                    mychannel.createKey(ptime,posvals[4][2]);
                if(mychannel.name=="Rotation.P")
                    mychannel.createKey(ptime,posvals[5][2]);
                if(mychannel.name=="Rotation.B")
                    mychannel.createKey(ptime,posvals[6][2]);
            }
    
            if(myscach && !pobj.isCamera())
            {
                if(mychannel.name=="Scale.X" && posvals[7][2])
                    mychannel.createKey(ptime,posvals[7][2]);
                if(mychannel.name=="Scale.Y" && posvals[8][2])
                    mychannel.createKey(ptime,posvals[8][2]);
                if(mychannel.name=="Scale.Z" && posvals[9][2])
                    mychannel.createKey(ptime,posvals[9][2]);
            }

            mychannel=mygroup.nextChannel();
        }
    }
    else
    {
        while(mychannel)
        {
            if(myposch)
            {
                if(mychannel.name=="Position.X" && posvals[1][1] )
                    mychannel.createKey(ptime,posvals[1][2]);
                if(mychannel.name=="Position.Y" && posvals[2][1])
                    mychannel.createKey(ptime,posvals[2][2]);
                if(mychannel.name=="Position.Z" && posvals[3][1])
                    mychannel.createKey(ptime,posvals[3][2]);
            }

            if(myrotch)
            {
                if(mychannel.name=="Rotation.H" && posvals[4][1])
                    mychannel.createKey(ptime,posvals[4][2]);
                if(mychannel.name=="Rotation.P" && posvals[5][1])
                    mychannel.createKey(ptime,posvals[5][2]);
                if(mychannel.name=="Rotation.B" && posvals[6][1])
                    mychannel.createKey(ptime,posvals[6][2]);
            }

            if(myscach && !pobj.isCamera())
            {
                if(mychannel.name=="Scale.X" && posvals[7][2] && posvals[7][1])
                    mychannel.createKey(ptime,posvals[7][2]);
                if(mychannel.name=="Scale.Y" && posvals[8][2] && posvals[8][1])
                    mychannel.createKey(ptime,posvals[8][2]);
                if(mychannel.name=="Scale.Z" && posvals[9][2] && posvals[9][1])
                    mychannel.createKey(ptime,posvals[9][2]);
            }
    
            mychannel=mygroup.nextChannel();
        }
    }
}
getfullpose:pobj,ptime
{
    fullpose=nil;
    poseindex=2;
    fullpose[1][1]= pobj.name;
    fullpose[1][2]= getpose(pobj,ptime);

    if(myobjch<3)
        getnode(pobj,pobj.firstChild(),ptime);

    return(fullpose);
}

getposeselected:pobjs,ptime
{
    for(i=1;i<=pobjs.size();i++)
    {
        fullpose[i][1]=pobjs[i].id;
        fullpose[i][2]=getpose(pobjs[i],ptime);
    }
}

getnode:pparent,pchild,ptime
{
    if(!pchild)
        return;
    fullpose[poseindex][1]=pchild.name;
    fullpose[poseindex][2]=getpose(pchild,ptime);
    poseindex++;
    
    getnode(pchild,pchild.firstChild(),ptime);
    getnode(pparent,pparent.nextChild(),ptime);
}

getpose:pobj,ptime
{
   //get position data
    groupname=pobj.name;

    mygroup=ChannelGroup(groupname);

    if(pobj.isBone())
    {
        myparent=pobj.parent;
        while(myparent.parent)
        {
            myparent=myparent.parent; // WORK STARTS HERE.
        }
        myovergroup=ChannelGroup(myparent.name);
        mygroup=ChannelGroup(myovergroup);
        while(mygroup)
        {
            if(mygroup.name==pobj.name)
                break;
            mygroup=mygroup.next();
        }
    }

    mychannel=mygroup.firstChannel();
    while(mychannel)
    {
        if(mychannel.name=="Position.X")
            posind=1;
        else if(mychannel.name=="Position.Y")
            posind=2;
        else if(mychannel.name=="Position.Z")
            posind=3;
        else if(mychannel.name=="Rotation.H")
            posind=4;
        else if(mychannel.name=="Rotation.P")
            posind=5;
        else if(mychannel.name=="Rotation.B")
            posind=6;
        else if(mychannel.name=="Scale.X")
            posind=7;
        else if(mychannel.name=="Scale.Y")
            posind=8;
        else if(mychannel.name=="Scale.Z")
            posind=9;

        mypos[posind][1]=mychannel.keyExists(ptime);
        if(mypos[posind][1]==nil)
        {
            myval=mychannel.value(ptime);
            if(posind>=4 && posind<=6)
                myval=myval/PI *180;
        }
        else
            myval=mychannel.getKeyValue(mypos[posind][1]);

        mypos[posind][2]=myval;

        mychannel=mygroup.nextChannel();
    }

    return(mypos);

}

printpos:pobj
{
    mygroup=ChannelGroup(pobj.name);
    mychannel=mygroup.firstChannel();
    for(i=1;i<=mychannel.keyCount;i++)
    {
        mykeyid=mychannel.keys[i];
        info("Position at time:"+mychannel.getKeyTime(mykeyid) + " Value:"+mychannel.getKeyValue(mykeyid));
    }
}



